; Zeliard (for IBM-PC/AT)  (C)Sierra On-Line/GAME ARTS
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

start:		cli
		mov	sp,stack
		mov	bx,prgend
		shr	bx,4
		mov	ah,0x4a			; [DOS] ubN̏k(ES:BX)
		int	0x21
		jnc	.skip1
		hlt

.skip1:		mov	bx,0x1000		; 傫64K
		mov	ah,0x48			; [DOS] 蓖
		int	0x21
		jnc	.skip2
		hlt
.skip2:		mov	[cs:music_int+2],ax	; 蓖ăAhXۑ
		mov	[cs:sound_int+2],ax

		mov	es,ax			; 蓖Ă[NA
		xor	di,di
		xor	ax,ax
		mov	cx,0x8000
		rep	stosw

musdrvload:	mov	ax,es
		mov	ds,ax
		mov	dx,0x0100		; yhCõ[hItZbg
		mov	bx,0x0005		; yhCõt@Cnh
		mov	ah,0x3f			; [DOS] read hundle (DS:DX)
		mov	cx,0xffff
		int	0x21			; yhCo[h

snddrvload:	mov	dx,0x1100		; ʉhCõ[hItZbg
		mov	bx,0x0006		; ʉhCõt@Cnh
		mov	ah,0x3f			; [DOS] read hundle (DS:DX)
		mov	cx,0xffff
		int	0x21			; ʉhCo[h

		mov	ax,0x2560		; INT 60 ~[WbNhCot@NVtbN
		mov	dx,0x0103
		int	0x21

		mov	ax,0x0001		; t~
		int	0x60

		mov	ax,cs
		mov	ds,ax
		mov	dx,int_timer_entry
		mov	ax,0x2508		; ^C}݃tbN
		int	0x21

		mov	al,0x36			; PIT #0 JE^Zbg
		out	0x0043,al
		mov	al,0xb1
		out	0x0040,al
		mov	al,0x13
		out	0x0040,al

		mov	ax,cs
		mov	ds,ax
		mov	ax,0x257f		; hoothCoo^
		mov	dx,vect_7f
		int	0x21

		sti
mainloop:	mov	ax,0x9801		; _~[|[O
		int	0x18
		jmp	short mainloop

int_timer_entry:
		pusha
		push	ds
		push	es
		cld
;		call	far [cs:sound_int]	; ʉ݃[`Ăяo
		call	far [cs:music_int]	; y݃[`Ăяo
		mov	al,0x20			; EOIs
		out	0x0020,al
		pop	es
		pop	ds
		popa
		iret

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .stop
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		mov	ax,0x0001		; t~
		int	0x60

		cli
		mov	es,[cs:driverseg]	; ȃf[^obt@KɃNA
		mov	di,0x2f00
		mov	cx,0x3000/2+0x0100
		rep	stosw

		mov	dx,HOOTPORT+2		; ȃf[^̃t@Cnh擾
		in	al,dx
		xor	ah,ah
		xchg	bx,ax

		xor	cx,cx			; t@C擪ɃV[N
		xor	dx,dx
		mov	ax,0x4200
		int	0x21

		mov	ds,[cs:driverseg]
		mov	dx,0x2f00		; wb_ǂݍ݃AhX
		mov	bp,dx
		mov	cx,0x0008		; wb_TCY
		mov	ah,0x3f
		int	0x21			; wb_ǂݍ

		mov	dx,HOOTPORT+4		; t@C^Cv擾(0x00=MT32,0x01=̑)
		in	al,dx
		and	ax,0x0001
		add	ax,ax			; *2
		xchg	si,ax
		mov	dx,[ds:si+bp+0x0002]	; t@CItZbg擾
		xor	cx,cx
		mov	ax,0x4201		; ݈ʒuCX:DXɃt@C|C^ړ
		int	0x21

.music_load:	mov	cx,[ds:si+bp+0x0004]	; t@CTCY
		mov	dx,0x3000		; ȃf[^[hItZbg
		mov	ah,0x3f
		int	0x21			; ȃf[^ǂݍ

		mov	si,dx
		xor	ax,ax			; tJn DS:SI=ȃf[^AhX
		int	0x60
		jmp	short .ed

.stop:		mov	ax,0x0001		; t~
		int	0x60
		jmp	short .ed

; far callpGg
music_int:	dw	0x0100
		dw	0

sound_int:	dw	0x1100
		dw	0

driverseg	equ	music_int+2

		times 0x200 db 0x00		; X^bNGA
stack:

		align	0x10
prgend:		

		ends

